;compiled by SIMPLE version 2.02
;rem Simple code to make a PIC12F675 blink GP0 on and off
;rem but only if it correctly computes other stuff first (11/10/12)

;rem assembler-specific directives
 list p=12f675
 radix dec
 include <p12f675.inc>
 __CONFIG _WDT_OFF & _MCLRE_OFF & _PWRTE_ON & _CP_OFF & _CPD_OFF & _INTRC_OSC_NOCLKOUT
 errorlevel -302 

;rambase 20H

#define hiregs STATUS,RP0 ;for banking
#define pindirs 00000000B ;all outputs
#define outpin GPIO,0 ;output pin
#define ConstA 11 ;delay constants
#define ConstB 86
#define ConstC 166
CounterA EQU 0x20 ;for timing delay
CounterB EQU 0x21
CounterC EQU 0x22

 GOTO start ;jump to actual start
 ORG 8

start ;start of program code
;GPIO = 0
 CLRF GPIO
;INTCON = 0
 CLRF INTCON
;ADCON0 = 0
 CLRF ADCON0
;T1CON = 0
 CLRF T1CON
;CMCON = 7
 MOVLW 7
 MOVWF CMCON
;bitset hiregs
 BSF hiregs
;ANSEL = 0
 CLRF ANSEL
;PIE1 = 0
 CLRF PIE1
;WPU = 0
 CLRF WPU
;IOC = 0
 CLRF IOC
;OPTION_REG = 11001101B
 MOVLW 11001101B
 MOVWF OPTION_REG
;TRISIO = #pindirs
 MOVLW pindirs
 MOVWF TRISIO
;bitclear hiregs
 BCF hiregs

;rem validate stuff
;rem goto hang if error

VarA EQU 0x23
VarB EQU 0x24
VarC EQU 0x25

;VarA = 10
 MOVLW 10
 MOVWF VarA
;VarB = 5
 MOVLW 5
 MOVWF VarB
;VarC = VarA + VarB
 MOVF VarA,0
 MOVWF VarC
 MOVF VarB,0
 ADDWF VarC,1
;VarC = VarC + VarA
 MOVF VarA,0
 ADDWF VarC,1
;if VarC <> 25 goto hang
 MOVLW 25
 SUBWF VarC,0
 BTFSS 3,2
 GOTO hang
;if VarC < 25 goto hang
 MOVLW 25
 SUBWF VarC,0
 BTFSS 3,0
 GOTO hang
;if VarC > 25 goto hang
 MOVLW 25^0xFF
 ADDWF VarC,0
 BTFSC 3,0
 GOTO hang
;if VarC = VarA goto hang
 MOVF VarA,0
 SUBWF VarC,0
 BTFSC 3,2
 GOTO hang
;if VarC <= VarA goto hang
 MOVF VarC,0
 SUBWF VarA,0
 BTFSC 3,0
 GOTO hang
;if VarA >= VarC goto hang
 MOVF VarC,0
 SUBWF VarA,0
 BTFSC 3,0
 GOTO hang
;if VarC = 25 then
 MOVLW 25
 SUBWF VarC,0
 BTFSS 3,2
 GOTO ifnext__10
; if VarC >= 25 then
 MOVLW 25
 SUBWF VarC,0
 BTFSS 3,0
 GOTO ifnext__20
;  if VarC <= 25 then
 MOVLW 25^0xFF
 ADDWF VarC,0
 BTFSC 3,0
 GOTO ifnext__30
;   increment VarA
 INCF VarA,1
;   if VarA >= 10 then
 MOVLW 10
 SUBWF VarA,0
 BTFSS 3,0
 GOTO ifnext__40
;    VarA = VarA - 2
 MOVLW 2
 SUBWF VarA,1
;    if VarA <= 8 then
 MOVLW 8^0xFF
 ADDWF VarA,0
 BTFSC 3,0
 GOTO ifnext__50
 GOTO hang
;    else
 GOTO ifend__50
ifnext__50
;     decrement VarA
 DECF VarA,1
;     VarA = VarA + 1
 INCF VarA,1
;     VarA = VarA - 1
 DECF VarA,1
;     if VarA = 8 goto domorecomp
 MOVLW 8
 SUBWF VarA,0
 BTFSC 3,2
 GOTO domorecomp
;    endif
ifend__50
;   endif
ifnext__40
;  endif
ifnext__30
; endif
ifnext__20
;endif
ifnext__10
 GOTO hang

domorecomp
;VarA = 10
 MOVLW 10
 MOVWF VarA
;VarB = 11
 MOVLW 11
 MOVWF VarB
;if VarA >= 10 then
 MOVLW 10
 SUBWF VarA,0
 BTFSS 3,0
 GOTO ifnext__11
; if VarB <= 11 then
 MOVLW 11^0xFF
 ADDWF VarB,0
 BTFSC 3,0
 GOTO ifnext__21
;  if VarA > 9 then
 MOVLW 9^0xFF
 ADDWF VarA,0
 BTFSS 3,0
 GOTO ifnext__31
;   if VarB < 12 then
 MOVLW 12
 SUBWF VarB,0
 BTFSC 3,0
 GOTO ifnext__41
;    if VarA < VarB then
 MOVF VarB,0
 SUBWF VarA,0
 BTFSC 3,0
 GOTO ifnext__51
;     if VarB > VarA then
 MOVF VarB,0
 SUBWF VarA,0
 BTFSC 3,0
 GOTO ifnext__60
;      rem make sure labels get generated right
;      loop VarA from 10
 MOVLW 10
 MOVWF VarA
local__10
;       loop VarB from 10
 MOVLW 10
 MOVWF VarB
local__20
;        loop VarC from 10
 MOVLW 10
 MOVWF VarC
local__30
;        next VarC
 DECFSZ VarC,1
 GOTO local__30
;       next VarB
 DECFSZ VarB,1
 GOTO local__20
;      next VarA
 DECFSZ VarA,1
 GOTO local__10
 GOTO compok
;     endif
ifnext__60
;    endif
ifnext__51
;   endif
ifnext__41
;  endif
ifnext__31
; endif
ifnext__21
;endif
ifnext__11
 GOTO hang

compok
;array ArrayD(6)
ArrayD EQU 0x26
NextByte EQU 0x2C
;NextByte = 10
 MOVLW 10
 MOVWF NextByte
;ArrayD(0) = 0
 MOVLW ArrayD
 MOVWF 4
 MOVLW 0
 ADDWF 4,1
 MOVLW 0
 MOVWF 0
;ArrayD(1) = 2
 MOVLW ArrayD
 MOVWF 4
 MOVLW 1
 ADDWF 4,1
 MOVLW 2
 MOVWF 0
;ArrayD(3) = 4
 MOVLW ArrayD
 MOVWF 4
 MOVLW 3
 ADDWF 4,1
 MOVLW 4
 MOVWF 0
;ArrayD(5) = 7
 MOVLW ArrayD
 MOVWF 4
 MOVLW 5
 ADDWF 4,1
 MOVLW 7
 MOVWF 0
;VarB = ArrayD(5)
 MOVLW ArrayD
 MOVWF 4
 MOVLW 5
 ADDWF 4,1
 MOVF 0,0
 MOVWF VarB
;if VarB <> 7 goto hang
 MOVLW 7
 SUBWF VarB,0
 BTFSS 3,2
 GOTO hang
;VarB = ArrayD(1)
 MOVLW ArrayD
 MOVWF 4
 MOVLW 1
 ADDWF 4,1
 MOVF 0,0
 MOVWF VarB
;if VarB <> 2 goto hang
 MOVLW 2
 SUBWF VarB,0
 BTFSS 3,2
 GOTO hang
;VarA = 3
 MOVLW 3
 MOVWF VarA
;VarB = ArrayD(VarA)
 MOVLW ArrayD
 MOVWF 4
 MOVF VarA,0
 ADDWF 4,1
 MOVF 0,0
 MOVWF VarB
;if VarB <> 4 goto hang
 MOVLW 4
 SUBWF VarB,0
 BTFSS 3,2
 GOTO hang
;if NextByte <> 10 goto hang
 MOVLW 10
 SUBWF NextByte,0
 BTFSS 3,2
 GOTO hang

;rem test bit stuff
Bits EQU 0x2D
;bitset Bits.0
 BSF Bits,0
;bitcopy Bits.1 = Bits.0
 BTFSS Bits,0
 BCF Bits,1
 BTFSC Bits,0
 BSF Bits,1
;bitcopy Bits.2 = not Bits.1
 BTFSC Bits,1
 BCF Bits,2
 BTFSS Bits,1
 BSF Bits,2
;if not Bits.0 goto hang
 BTFSS Bits,0
 GOTO hang
;if not Bits.1 goto hang
 BTFSS Bits,1
 GOTO hang
;if Bits.2 goto hang
 BTFSC Bits,2
 GOTO hang
;if Bits.0 then
 BTFSS Bits,0
 GOTO ifnext__12
; if Bits.1 then
 BTFSS Bits,1
 GOTO ifnext__22
;  if not Bits.2 then
 BTFSC Bits,2
 GOTO ifnext__32
 GOTO bitsok
;  endif
ifnext__32
; endif
ifnext__22
;endif
ifnext__12
 GOTO hang
bitsok

;rem test other stuff
;VarA = 10000001B
 MOVLW 10000001B
 MOVWF VarA
;shift VarA left
 BCF 3,0
 RLF VarA,1
;if VarA.1 then
 BTFSS VarA,1
 GOTO ifnext__13
; if not VarA.0 then
 BTFSC VarA,0
 GOTO ifnext__23
;  if not VarA.7 then
 BTFSC VarA,7
 GOTO ifnext__33
;   bitset VarA.7
 BSF VarA,7
;   shift VarA right
 BCF 3,0
 RRF VarA,1
;   if not VarA.7 then
 BTFSC VarA,7
 GOTO ifnext__42
;    if VarA.6 then
 BTFSS VarA,6
 GOTO ifnext__52
 GOTO shiftok
;    endif
ifnext__52
;   endif
ifnext__42
;  endif
ifnext__33
; endif
ifnext__23
;endif
ifnext__13
 GOTO hang
shiftok

;VarA = 20
 MOVLW 20
 MOVWF VarA
;VarB = 3
 MOVLW 3
 MOVWF VarB
;VarA = VarA + 2
 MOVLW 2
 ADDWF VarA,1
;VarA = VarA - VarB
 MOVF VarB,0
 SUBWF VarA,1
;if VarA <> 19 goto hang
 MOVLW 19
 SUBWF VarA,0
 BTFSS 3,2
 GOTO hang
;VarA = #0xFF  ;must use # for immediate
 MOVLW 0xFF
 MOVWF VarA
;VarA = not VarA
 COMF VarA,1
;if VarA <> 0 goto hang
 MOVLW 0
 SUBWF VarA,0
 BTFSS 3,2
 GOTO hang
;VarA = VarA or #00000101B
 MOVLW 00000101B
 IORWF VarA,1
;if VarA <> #00000101B goto hang
 MOVLW 00000101B
 SUBWF VarA,0
 BTFSS 3,2
 GOTO hang
;VarA = VarA and #00000110B
 MOVLW 00000110B
 ANDWF VarA,1
;if VarA <> #00000100B goto hang
 MOVLW 00000100B
 SUBWF VarA,0
 BTFSS 3,2
 GOTO hang
;VarA = VarA xor #11111111B
 MOVLW 11111111B
 XORWF VarA,1
;if VarA <> #11111011B goto hang
 MOVLW 11111011B
 SUBWF VarA,0
 BTFSS 3,2
 GOTO hang

;VarA = VarB
 MOVF VarB,0
 MOVWF VarA

var1 EQU 0x2E
var2 EQU 0x2F
var3 EQU 0x30
;var1 = 21
 MOVLW 21
 MOVWF var1
;var2 = 25
 MOVLW 25
 MOVWF var2
#define constant 5
;var2 = var2 + #constant  ;use # if not a decimal number  ;var2=25+5=30
 MOVLW constant
 ADDWF var2,1
;var1 = var1 + var2  ;self reference must be first        ;var1=21+30=51
 MOVF var2,0
 ADDWF var1,1
;var2 = var1 + #constant                                  ;var2=51+5=56
 MOVF var1,0
 MOVWF var2
 MOVLW constant
 ADDWF var2,1
;var3 = var1 + var2                                       ;var3=51+56=107
 MOVF var1,0
 MOVWF var3
 MOVF var2,0
 ADDWF var3,1
;var1 = var3  ;for testing                                ;var1=107
 MOVF var3,0
 MOVWF var1
;var2 = var2 - #constant                                  ;var2=56-5=51
 MOVLW constant
 SUBWF var2,1
;var1 = var1 - var2                                       ;var1=107-51=56
 MOVF var2,0
 SUBWF var1,1
;var2 = var1 - 2                                          ;var2=56-2=54
 MOVF var1,0
 MOVWF var2
 MOVLW 2
 SUBWF var2,1
;var3 = var1 - var2                                       ;var3=56-54=2
 MOVF var1,0
 MOVWF var3
 MOVF var2,0
 SUBWF var3,1
;increment var3                                           ;var3=2+1=3
 INCF var3,1
;decrement var3                                           ;var3=3-1=2
 DECF var3,1
;var1 = var1 + 1       ;optimized to an increment         ;var1=56+1=57
 INCF var1,1
;var1 = var1 - 1       ;optimized to a decrement          ;var1=57-1=56
 DECF var1,1
;var1 = var1 + var3    ;for testing to propagate var3     ;var1=56+2=58
 MOVF var3,0
 ADDWF var1,1
;var3 = var2 + 1                                          ;var3=54+1=55
 MOVF var2,0
 MOVWF var3
 INCF var3,1
;var3 = var2 - 1                                          ;var3=55-1=54
 MOVF var2,0
 MOVWF var3
 DECF var3,1
;var1 = var1 and var2                                     ;var1=58 and 54=50
 MOVF var2,0
 ANDWF var1,1
;var2 = var1 and var3                                     ;var2=50 and 54=50
 MOVF var1,0
 MOVWF var2
 MOVF var3,0
 ANDWF var2,1
;var1 = var2 and 49                                       ;var1=50 and 49=48
 MOVF var2,0
 MOVWF var1
 MOVLW 49
 ANDWF var1,1
;var3 = var3 and #constant                                ;var3=54 and 5=4
 MOVLW constant
 ANDWF var3,1
;var1 = var1 or var2                                      ;var1=50 or 50=50
 MOVF var2,0
 IORWF var1,1
;var2 = var1 or var3                                      ;var2=50 or 4=54
 MOVF var1,0
 MOVWF var2
 MOVF var3,0
 IORWF var2,1
;var1 = var2 or #constant                                 ;var1=54 or 5=55
 MOVF var2,0
 MOVWF var1
 MOVLW constant
 IORWF var1,1
;var3 = var3 or #1010B                                    ;var3=4 or 10=14
 MOVLW 1010B
 IORWF var3,1
;var1 = var1 xor var2                                     ;var1=55 xor 54=1
 MOVF var2,0
 XORWF var1,1
;var2 = var1 xor var3                                     ;var2=1 xor 14=15
 MOVF var1,0
 MOVWF var2
 MOVF var3,0
 XORWF var2,1
;var1 = var2 xor #constant                                ;var1=15 xor 5=10
 MOVF var2,0
 MOVWF var1
 MOVLW constant
 XORWF var1,1
;var3 = var3 xor #0xFF                                    ;var3=14 xor 255=241
 MOVLW 0xFF
 XORWF var3,1
;var1 = not var1                                          ;var1=not 10=245
 COMF var1,1
;var3 = not var1                                          ;var3=not 245=10
 MOVF var1,0
 MOVWF var3
 COMF var3,1
err ;hang here if results not as expected
;if var3 <> 10 goto err
 MOVLW 10
 SUBWF var3,0
 BTFSS 3,2
 GOTO err

var_low EQU 0x31
var_high EQU 0x32
;var_low = #00110011B
 MOVLW 00110011B
 MOVWF var_low
;var_high = #01010101B
 MOVLW 01010101B
 MOVWF var_high
;word_pointer = #var_low
 MOVLW var_low
 MOVWF word_pointer
;gosub shift16left
 CALL shift16left
;gosub shift16left
 CALL shift16left
;gosub shift16right
 CALL shift16right
err1
;if var_low <> #01100110B goto err1
 MOVLW 01100110B
 SUBWF var_low,0
 BTFSS 3,2
 GOTO err1
;if var_high <> #00101010B goto err1
 MOVLW 00101010B
 SUBWF var_high,0
 BTFSS 3,2
 GOTO err1

;rem compute 2500-1500
;ACCbLO = #2500&255
 MOVLW 2500&255
 MOVWF ACCbLO
;ACCbHI = #2500>>8
 MOVLW 2500>>8
 MOVWF ACCbHI
;ACCaLO = #1500&255
 MOVLW 1500&255
 MOVWF ACCaLO
;ACCaHI = #1500>>8
 MOVLW 1500>>8
 MOVWF ACCaHI
;gosub D_sub
 CALL D_sub
;rem add 2000 to result
;ACCaLO = #2000&255
 MOVLW 2000&255
 MOVWF ACCaLO
;ACCaHI = #2000>>8
 MOVLW 2000>>8
 MOVWF ACCaHI
;gosub D_add
 CALL D_add
;rem ACCb should be 3000
errD
;if ACCbLO <> #3000&255 goto errD
 MOVLW 3000&255
 SUBWF ACCbLO,0
 BTFSS 3,2
 GOTO errD
;if ACCbHI <> #3000>>8  goto errD
 MOVLW 3000>>8
 SUBWF ACCbHI,0
 BTFSS 3,2
 GOTO errD

;rem test compare16 sub
#define equal c16result,0
#define lessthan c16result,1
#define greaterthan c16result,2
;c16n1 = ACCbLO
 MOVF ACCbLO,0
 MOVWF c16n1
;c16n1h = ACCbHI
 MOVF ACCbHI,0
 MOVWF c16n1h
;c16n2 = #3000&255
 MOVLW 3000&255
 MOVWF c16n2
;c16n2h = #3000>>8
 MOVLW 3000>>8
 MOVWF c16n2h
;gosub compare16
 CALL compare16
;if not equal goto hang
 BTFSS equal
 GOTO hang
;c16n2 = #2999&255
 MOVLW 2999&255
 MOVWF c16n2
;c16n2h = #2999>>8
 MOVLW 2999>>8
 MOVWF c16n2h
;gosub compare16
 CALL compare16
;if not greaterthan goto hang
 BTFSS greaterthan
 GOTO hang
;c16n2 = #3001&255
 MOVLW 3001&255
 MOVWF c16n2
;c16n2h = #3001>>8
 MOVLW 3001>>8
 MOVWF c16n2h
;gosub compare16
 CALL compare16
;if not lessthan goto hang
 BTFSS lessthan
 GOTO hang
;c16n1 = #65534&255
 MOVLW 65534&255
 MOVWF c16n1
;c16n1h = #65534>>8
 MOVLW 65534>>8
 MOVWF c16n1h
;c16n2 = #65534&255
 MOVLW 65534&255
 MOVWF c16n2
;c16n2h = #65534>>8
 MOVLW 65534>>8
 MOVWF c16n2h
;gosub compare16
 CALL compare16
;if not equal goto hang
 BTFSS equal
 GOTO hang
;c16n1 = #65534&255
 MOVLW 65534&255
 MOVWF c16n1
;c16n1h = #65534>>8
 MOVLW 65534>>8
 MOVWF c16n1h
;c16n2 = #65533&255
 MOVLW 65533&255
 MOVWF c16n2
;c16n2h = #65533>>8
 MOVLW 65533>>8
 MOVWF c16n2h
;gosub compare16
 CALL compare16
;if not greaterthan goto hang
 BTFSS greaterthan
 GOTO hang
;c16n2 = #65535&255
 MOVLW 65535&255
 MOVWF c16n2
;c16n2h = #65535>>8
 MOVLW 65535>>8
 MOVWF c16n2h
;gosub compare16
 CALL compare16
;if not lessthan goto hang
 BTFSS lessthan
 GOTO hang
;c16n1 = #240&255
 MOVLW 240&255
 MOVWF c16n1
;c16n1h = #240>>8
 MOVLW 240>>8
 MOVWF c16n1h
;c16n2 = #240&255
 MOVLW 240&255
 MOVWF c16n2
;c16n2h = #240>>8
 MOVLW 240>>8
 MOVWF c16n2h
;gosub compare16
 CALL compare16
;if not equal goto hang
 BTFSS equal
 GOTO hang
;c16n2 = #239&255
 MOVLW 239&255
 MOVWF c16n2
;c16n2h = #239>>8
 MOVLW 239>>8
 MOVWF c16n2h
;gosub compare16
 CALL compare16
;if not greaterthan goto hang
 BTFSS greaterthan
 GOTO hang
;c16n2 = #241&255
 MOVLW 241&255
 MOVWF c16n2
;c16n2h = #241>>8
 MOVLW 241>>8
 MOVWF c16n2h
;gosub compare16
 CALL compare16
;if not lessthan goto hang
 BTFSS lessthan
 GOTO hang

;rem test loop with a variable
;VarA = #ConstC
 MOVLW ConstC
 MOVWF VarA
;VarB = #ConstB
 MOVLW ConstB
 MOVWF VarB
;VarA = #ConstA
 MOVLW ConstA
 MOVWF VarA
;loop CounterC from VarC
 MOVF VarC,0
 MOVWF CounterC
local__11
; loop CounterB from VarB
 MOVF VarB,0
 MOVWF CounterB
local__21
;  loop CounterA from VarA
 MOVF VarA,0
 MOVWF CounterA
local__31
;  next CounterA
 DECFSZ CounterA,1
 GOTO local__31
; next CounterB
 DECFSZ CounterB,1
 GOTO local__21
;next CounterC
 DECFSZ CounterC,1
 GOTO local__11

;var1 = 7
 MOVLW 7
 MOVWF var1
loop1
;increment var1
 INCF var1,1
;if var1 <= 10 goto loop1
 MOVLW 10^0xFF
 ADDWF var1,0
 BTFSS 3,0
 GOTO loop1

internalloop EQU 0x33
;var1 = 7
 MOVLW 7
 MOVWF var1
;loop internalloop from 1
 MOVLW 1
 MOVWF internalloop
local__12
; increment var1
 INCF var1,1
; if var1 <= 10 then
 MOVLW 10^0xFF
 ADDWF var1,0
 BTFSC 3,0
 GOTO ifnext__14
;  increment internalloop ;keep looping
 INCF internalloop,1
; endif
ifnext__14
;next internalloop
 DECFSZ internalloop,1
 GOTO local__12

;var1 = 0
 CLRF var1
loop2
;if var1 >= 10 goto loop2end
 MOVLW 10
 SUBWF var1,0
 BTFSC 3,0
 GOTO loop2end
;increment var1 ;or whatever
 INCF var1,1
 GOTO loop2
loop2end

;var1 = 0
 CLRF var1
loop2a
;if var1 < 10 then
 MOVLW 10
 SUBWF var1,0
 BTFSC 3,0
 GOTO ifnext__15
; increment var1 ;or whatever
 INCF var1,1
 GOTO loop2a
;endif
ifnext__15

;var1 = 0
 CLRF var1
loop3
;increment var1 ;or whatever
 INCF var1,1
;if var1 <> 10 goto loop3
 MOVLW 10
 SUBWF var1,0
 BTFSS 3,2
 GOTO loop3

#define bit7 var1,7
;var1 = 0
 CLRF var1
loop4
;increment var1 ;or whatever
 INCF var1,1
;if not bit7 goto loop4
 BTFSS bit7
 GOTO loop4

;rem more bit stuff
flags EQU 0x34
#define bit0 flags,0
#define bit1 flags,1
#define bit2 flags,2
#define bit3 flags,3
;bitset bit0
 BSF bit0
;bitclear bit1
 BCF bit1
;bitcopy bit2 = bit0
 BTFSS bit0
 BCF bit2
 BTFSC bit0
 BSF bit2
;bitcopy bit3 = not bit1
 BTFSC bit1
 BCF bit3
 BTFSS bit1
 BSF bit3
;bitcopy bit3 = not bit3
 BTFSC bit3
 GOTO $ + 3
 BSF bit3
 GOTO $ + 2
 BCF bit3
;if not bit2 goto hang
 BTFSS bit2
 GOTO hang
;if bit3 goto hang
 BTFSC bit3
 GOTO hang
;rem a more efficient bit toggle
#define bit3xor 00001000B
#define bit2xor 00000100B
;flags = flags XOR #bit3xor
 MOVLW bit3xor
 XORWF flags,1
;flags = flags xor #bit2xor
 MOVLW bit2xor
 XORWF flags,1
;if bit2 goto hang
 BTFSC bit2
 GOTO hang
;If NOT bit3 goto hang
 BTFSS bit3
 GOTO hang

;rem more shift code
;var1 = #10110000B
 MOVLW 10110000B
 MOVWF var1
;shift var1 left
 BCF 3,0
 RLF var1,1
;if var1 <> #01100000B goto hang
 MOVLW 01100000B
 SUBWF var1,0
 BTFSS 3,2
 GOTO hang
;shift var1 right
 BCF 3,0
 RRF var1,1
;if var1 <> #00110000B goto hang
 MOVLW 00110000B
 SUBWF var1,0
 BTFSS 3,2
 GOTO hang

;var1 = #10000000B
 MOVLW 10000000B
 MOVWF var1
;rem rotate var1 left
;bitcopy STATUS.C = var1.7
 BTFSS var1,7
 BCF STATUS,C
 BTFSC var1,7
 BSF STATUS,C
 RLF var1,F
;if var1 <> #00000001B goto hang
 MOVLW 00000001B
 SUBWF var1,0
 BTFSS 3,2
 GOTO hang

;var2 = #00000001B
 MOVLW 00000001B
 MOVWF var2
;rem rotate var2 right
;bitcopy STATUS.C = var2.0
 BTFSS var2,0
 BCF STATUS,C
 BTFSC var2,0
 BSF STATUS,C
 RRF var2,F
;if var2 <> #10000000B goto hang
 MOVLW 10000000B
 SUBWF var2,0
 BTFSS 3,2
 GOTO hang

;rem test new bitflip
;flags = 0
 CLRF flags
;bitcopy bit3 = not bit3
 BTFSC bit3
 GOTO $ + 3
 BSF bit3
 GOTO $ + 2
 BCF bit3
;if not bit3 goto hang
 BTFSS bit3
 GOTO hang
;bitcopy bit3 = NOT bit3
 BTFSC bit3
 GOTO $ + 3
 BSF bit3
 GOTO $ + 2
 BCF bit3
;if bit3 goto hang
 BTFSC bit3
 GOTO hang
;if flags <> 0 goto hang
 MOVLW 0
 SUBWF flags,0
 BTFSS 3,2
 GOTO hang

;rem are comparisons really unsigned?
;var1 = 20
 MOVLW 20
 MOVWF var1
;var2 = 255
 MOVLW 255
 MOVWF var2
;if var1 > var2 goto hang
 MOVF var1,0
 SUBWF var2,0
 BTFSS 3,0
 GOTO hang
;if var1 >= var2 goto hang
 MOVF var2,0
 SUBWF var1,0
 BTFSC 3,0
 GOTO hang
;var1 = 175
 MOVLW 175
 MOVWF var1
;var2 = 50
 MOVLW 50
 MOVWF var2
;if var1 < var2 goto hang
 MOVF var2,0
 SUBWF var1,0
 BTFSS 3,0
 GOTO hang
;if var1 <= var2 goto hang
 MOVF var1,0
 SUBWF var2,0
 BTFSC 3,0
 GOTO hang
;var1 = 170
 MOVLW 170
 MOVWF var1
;var2 = 171
 MOVLW 171
 MOVWF var2
;if var1 > var2 goto hang
 MOVF var1,0
 SUBWF var2,0
 BTFSS 3,0
 GOTO hang
;if var1 >= var2 goto hang
 MOVF var2,0
 SUBWF var1,0
 BTFSC 3,0
 GOTO hang
;var2 = 169
 MOVLW 169
 MOVWF var2
;if var1 < var2 goto hang
 MOVF var2,0
 SUBWF var1,0
 BTFSS 3,0
 GOTO hang
;if var1 <= var2 goto hang
 MOVF var1,0
 SUBWF var2,0
 BTFSC 3,0
 GOTO hang
;rem yes they are!

blinkloop
;bitset outpin
 BSF outpin
;gosub delay
 CALL delay
;bitclear outpin
 BCF outpin
;gosub delay
 CALL delay
 GOTO blinkloop

delay
;loop CounterC from #ConstC
 MOVLW ConstC
 MOVWF CounterC
local__13
; loop CounterB from #ConstB
 MOVLW ConstB
 MOVWF CounterB
local__22
;  loop CounterA from #ConstA
 MOVLW ConstA
 MOVWF CounterA
local__32
;  next CounterA
 DECFSZ CounterA,1
 GOTO local__32
; next CounterB
 DECFSZ CounterB,1
 GOTO local__22
;next CounterC
 DECFSZ CounterC,1
 GOTO local__13
;return
 RETLW 0

hang
 GOTO hang

;rem ======== GP subroutines ========

;rem 16 bit shift subroutines
;rem word_pointer = 2 byte ram loc to shift
word_pointer EQU 0x35
#define FSreg 4
#define FSmem 0

;rem shift (word_pointer) left
shift16left
;FSreg = word_pointer
 MOVF word_pointer,0
 MOVWF FSreg
;shift FSmem left
 BCF 3,0
 RLF FSmem,1
;increment FSreg
 INCF FSreg,1
 RLF FSmem,F
;return
 RETLW 0

;rem shift (word_pointer) right
shift16right
;FSreg = word_pointer
 MOVF word_pointer,0
 MOVWF FSreg
;increment FSreg
 INCF FSreg,1
;shift FSmem right
 BCF 3,0
 RRF FSmem,1
;decrement FSreg
 DECF FSreg,1
 RRF FSmem,F
;return
 RETLW 0

;rem 16 bit add/subtract/negate
;rem ACCbLO and ACCbHI is the accumulator
;rem gosub D_add to add ACCaLO and ACCaHI to the accumulator
;rem gosub D_sub to subract ACCaLO and ACCaHI from the accumulator
;rem gosub neg_A to 2's complement ACCaLO and ACCaHI
;rem note - D_sub uses an extra stack level
;rem adapted from Microchip AN526 16 bit add/sub routines
ACCaLO EQU 0x36
ACCaHI EQU 0x37
ACCbLO EQU 0x38
ACCbHI EQU 0x39
;rem ACCb=ACCb-ACCa
D_sub
;gosub neg_A
 CALL neg_A
;rem ACCb=ACCb+ACCa
D_add
 movf  ACCaLO,W
 addwf ACCbLO,F
 btfsc STATUS,C
 incf  ACCbHI,F
 movf  ACCaHI,W
 addwf ACCbHI,F
;return
 RETLW 0
;rem ACCa=not ACCa
neg_A
 comf  ACCaLO,F
 incf  ACCaLO,F
 btfsc STATUS,Z
 decf  ACCaHI,F
 comf  ACCaHI,F
;return
 RETLW 0

;rem compare16 - a subroutine for 16 bit unsigned compare
;rem set c16n1 and c16n1h to a number
;rem set c16n2 and c16n2h to another number
;rem gosub compare16
;rem returns c16result = 1 (bit 0) if equal
;rem         c16result = 2 (bit 1) if c16n1 < c16n2
;rem         c16result = 4 (bit 2) if c16n1 > c16n2
;rem input bytes are not changed
c16n1 EQU 0x3A
c16n1h EQU 0x3B
c16n2 EQU 0x3C
c16n2h EQU 0x3D
c16temp EQU 0x3E
c16result EQU 0x3F
compare16
;c16result = 0 ;opt to clrf
 CLRF c16result
;bitset c16result.2 ;default 4 for gt
 BSF c16result,2
;rem check for equal
;if c16n1h = c16n2h then
 MOVF c16n2h,0
 SUBWF c16n1h,0
 BTFSS 3,2
 GOTO ifnext__16
; if c16n1 = c16n2 then
 MOVF c16n2,0
 SUBWF c16n1,0
 BTFSS 3,2
 GOTO ifnext__24
;  c16result = 0
 CLRF c16result
;  bitset c16result.0 ;return 1 for equal
 BSF c16result,0
; else ;check for LT in low byte
 GOTO ifend__24
ifnext__24
;  c16temp = c16n1 - c16n2
 MOVF c16n1,0
 MOVWF c16temp
 MOVF c16n2,0
 SUBWF c16temp,1
;  if not STATUS.C then ;c16n1 < c16n2
 BTFSC STATUS,C
 GOTO ifnext__34
 RRF c16result,F 
;  endif                ;return 2 for lt (high bytes equal)
ifnext__34
; endif
ifend__24
;else ;check for LT in high byte
 GOTO ifend__16
ifnext__16
; c16temp = c16n1h - c16n2h
 MOVF c16n1h,0
 MOVWF c16temp
 MOVF c16n2h,0
 SUBWF c16temp,1
; if not STATUS.C then ;c16n1h < c16n2h
 BTFSC STATUS,C
 GOTO ifnext__25
 RRF c16result,F 
; endif
ifnext__25
;endif
ifend__16
;return
 RETLW 0

 end

