;compiled by SIMPLE version 2.02
;rem Blink an LED attached to pin 7 of a PIC12F675 chip
;rem assembler-specific directives
 list p=12f675
 radix dec
 include <p12f675.inc>
 __CONFIG _WDT_OFF & _MCLRE_OFF & _PWRTE_ON & _CP_OFF & _CPD_OFF & _INTRC_OSC_NOCLKOUT
 errorlevel -302 

#define hiregs STATUS,RP0 ;for banking
#define pindirs 111110B ;make GPIO.0 an output
#define outpin GPIO,0 ;output pin
#define ConstA 11 ;delay constants
#define ConstB 86
#define ConstC 166
CounterA EQU 0x28 ;for timing delay
CounterB EQU 0x29
CounterC EQU 0x2A

 GOTO start ;jump to actual start
 ORG 8

start ;start of program code
;GPIO = 0                  ;clear GPIO register
 CLRF GPIO
;INTCON = 0                ;no interrupts
 CLRF INTCON
;ADCON0 = 0                ;disable A-D
 CLRF ADCON0
;T1CON = 0                 ;disable timer
 CLRF T1CON
;CMCON = 7                 ;disable compare
 MOVLW 7
 MOVWF CMCON
;bitset hiregs             ;select high registers
 BSF hiregs
;TRISIO = #pindirs         ;set pin directions
 MOVLW pindirs
 MOVWF TRISIO
;ANSEL = 0                 ;set all analog inputs to digital
 CLRF ANSEL
;PIE1 = 0                  ;disable peripheral interrupts
 CLRF PIE1
;IOC = 0                   ;disable interrupt on change
 CLRF IOC
;WPU = 0                   ;disable weak pullups
 CLRF WPU
;OPTION_REG = #11001101B   ;typical options
 MOVLW 11001101B
 MOVWF OPTION_REG
;bitclear hiregs
 BCF hiregs

blinkloop
;bitset outpin
 BSF outpin
;gosub delay
 CALL delay
;bitclear outpin
 BCF outpin
;gosub delay
 CALL delay
 GOTO blinkloop

delay
;loop CounterC from #ConstC
 MOVLW ConstC
 MOVWF CounterC
local__10
; loop CounterB from #ConstB
 MOVLW ConstB
 MOVWF CounterB
local__20
;  loop CounterA from #ConstA
 MOVLW ConstA
 MOVWF CounterA
local__30
;  next CounterA
 DECFSZ CounterA,1
 GOTO local__30
; next CounterB
 DECFSZ CounterB,1
 GOTO local__20
;next CounterC
 DECFSZ CounterC,1
 GOTO local__10
;return
 RETLW 0

 end

