;compiled by SIMPLE version 2.02
;rem EE subs and analog input test for PIC12F675...
;rem if AN0 > 2V then blink an LED attached to pin 6
;rem if AN0 > 4V then light the LED solid
;rem otherwise don't light LED

;rem assembler-specific directives
 list p=12f675
 radix dec
 include <p12f675.inc>
 __CONFIG _WDT_OFF & _MCLRE_OFF & _PWRTE_ON & _CP_OFF & _CPD_OFF & _INTRC_OSC_NOCLKOUT
 errorlevel -302 

#define hiregs STATUS,RP0 ;for banking
#define pindirs 100001B ;make GPIO.0,6 input, GPIO.1-4 output
#define outpin GPIO,1 ;output pin

 GOTO start ;jump to actual start
 ORG 8

start ;start of program code
;GPIO = 0                  ;clear GPIO register
 CLRF GPIO
;INTCON = 0                ;no interrupts
 CLRF INTCON
;ADCON0 = 0                ;disable A-D (for now)
 CLRF ADCON0
;T1CON = 0                 ;disable timer
 CLRF T1CON
;CMCON = 7                 ;disable compare
 MOVLW 7
 MOVWF CMCON
;bitset hiregs             ;select high registers
 BSF hiregs
;TRISIO = #pindirs         ;set pin directions
 MOVLW pindirs
 MOVWF TRISIO
;ANSEL = 0                 ;set all analog inputs to digital
 CLRF ANSEL
;PIE1 = 0                  ;disable peripheral interrupts
 CLRF PIE1
;IOC = 0                   ;disable interrupt on change
 CLRF IOC
;WPU = 0                   ;disable weak pullups
 CLRF WPU
;OPTION_REG = #11001101B   ;typical options
 MOVLW 11001101B
 MOVWF OPTION_REG
;bitclear hiregs
 BCF hiregs

;eeaddress = 10
 MOVLW 10
 MOVWF eeaddress
;eebyte = 100
 MOVLW 100
 MOVWF eebyte
;gosub WriteEE
 CALL WriteEE
;eeaddress = 20
 MOVLW 20
 MOVWF eeaddress
;eebyte = 200
 MOVLW 200
 MOVWF eebyte
;gosub WriteEE
 CALL WriteEE

;eeaddress = 10
 MOVLW 10
 MOVWF eeaddress
;gosub ReadEE
 CALL ReadEE
ee_err1
;if eebyte <> 100 goto ee_err1
 MOVLW 100
 SUBWF eebyte,0
 BTFSS 3,2
 GOTO ee_err1
;eeaddress = 20
 MOVLW 20
 MOVWF eeaddress
;gosub ReadEE
 CALL ReadEE
ee_err2
;if eebyte <> 200 goto ee_err2
 MOVLW 200
 SUBWF eebyte,0
 BTFSS 3,2
 GOTO ee_err2

mainloop
;adchannel = 0
 CLRF adchannel
;gosub ReadAD
 CALL ReadAD
;if voltagebyte > 204 goto solid
 MOVLW 204^0xFF
 ADDWF voltagebyte,0
 BTFSC 3,0
 GOTO solid
;if voltagebyte > 102 goto blink
 MOVLW 102^0xFF
 ADDWF voltagebyte,0
 BTFSC 3,0
 GOTO blink
;bitclear outpin
 BCF outpin
 GOTO mainloop

blink
;bitset outpin
 BSF outpin
;gosub delay
 CALL delay
;bitclear outpin
 BCF outpin
;gosub delay
 CALL delay
 GOTO mainloop

solid
;bitset outpin
 BSF outpin
 GOTO mainloop

delay
;milliseconds = 250
 MOVLW 250
 MOVWF milliseconds
;gosub MSdelay
 CALL MSdelay
;gosub MSdelay
 CALL MSdelay
;return
 RETLW 0

;rem 256-byte eeprom subroutines (128-byte for '629/675)
eeaddress EQU 0x28 ;set to address to read/write
eebyte EQU 0x29 ;data to write or data read

ReadEE
 MOVF eeaddress,W
 BSF STATUS,RP0
 MOVWF EEADR
 BSF EECON1,RD
 MOVF EEDAT,W
 BCF STATUS,RP0
 MOVWF eebyte
;return
 RETLW 0

WriteEE
;rem assumes interupts are disabled!
 MOVF eeaddress,W
 BSF STATUS,RP0
 MOVWF EEADR
 BCF STATUS,RP0
 MOVF eebyte,W
 BSF STATUS,RP0
 MOVWF EEDAT
 BSF EECON1,WREN
 MOVLW 0x55
 MOVWF EECON2
 MOVLW 0xAA
 MOVWF EECON2
 BSF EECON1,WR
waitforeewrite
 BTFSC EECON1,WR
 GOTO waitforeewrite
 BCF EECON1,WREN
 BCF STATUS,RP0
;return
 RETLW 0

;rem read analog pin for PIC12F675
;rem tristate register must already be set to input
;rem this is chip-specific, code is similar for other
;rem PICs but control bits are in different registers
;rem This sub is kind of bloated in an attempt to make GP

adchannel EQU 0x2A ;set to channel to read, 0-3
voltagelow EQU 0x2B ;lower 8 bits of 10-bit result
voltagehigh EQU 0x2C ;upper 2 bits of 10-bit result
voltagebyte EQU 0x2D ;8 bit result
adtemp EQU 0x2E

ReadAD
;bitset STATUS.RP0
 BSF STATUS,RP0
;ANSEL = #00000001B
 MOVLW 00000001B
 MOVWF ANSEL
;bitclear STATUS.RP0
 BCF STATUS,RP0
;if adchannel > 0 then
 MOVLW 0^0xFF
 ADDWF adchannel,0
 BTFSS 3,0
 GOTO ifnext__10
; loop adtemp from adchannel
 MOVF adchannel,0
 MOVWF adtemp
local__10
;  bitset STATUS.RP0
 BSF STATUS,RP0
;  shift ANSEL left
 BCF 3,0
 RLF ANSEL,1
;  bitclear STATUS.RP0
 BCF STATUS,RP0
; next adtemp
 DECFSZ adtemp,1
 GOTO local__10
;endif
ifnext__10
;adtemp = adchannel
 MOVF adchannel,0
 MOVWF adtemp
;shift adtemp left
 BCF 3,0
 RLF adtemp,1
;shift adtemp left
 BCF 3,0
 RLF adtemp,1
;ADCON0 = adtemp
 MOVF adtemp,0
 MOVWF ADCON0
;bitset ADCON0.ADFM
 BSF ADCON0,ADFM
;bitset ADCON0.ADON
 BSF ADCON0,ADON
;loop adtemp from 100 ;delay for AD to power up
 MOVLW 100
 MOVWF adtemp
local__11
;next adtemp
 DECFSZ adtemp,1
 GOTO local__11
;bitset ADCON0.GO_DONE
 BSF ADCON0,GO_DONE
WaitForVoltage
;if ADCON0.GO_DONE goto WaitForVoltage
 BTFSC ADCON0,GO_DONE
 GOTO WaitForVoltage
;bitset STATUS.RP0
 BSF STATUS,RP0
 MOVF ADRESL,W
;bitclear STATUS.RP0
 BCF STATUS,RP0
 MOVWF voltagelow
;bitclear ADCON0.ADON
 BCF ADCON0,ADON
;voltagehigh = ADRESH
 MOVF ADRESH,0
 MOVWF voltagehigh
;voltagebyte = voltagelow
 MOVF voltagelow,0
 MOVWF voltagebyte
;shift voltagebyte right
 BCF 3,0
 RRF voltagebyte,1
;shift voltagebyte right
 BCF 3,0
 RRF voltagebyte,1
;bitcopy voltagebyte.6 = voltagehigh.0
 BTFSS voltagehigh,0
 BCF voltagebyte,6
 BTFSC voltagehigh,0
 BSF voltagebyte,6
;bitcopy voltagebyte.7 = voltagehigh.1
 BTFSS voltagehigh,1
 BCF voltagebyte,7
 BTFSC voltagehigh,1
 BSF voltagebyte,7
;return
 RETLW 0

;rem delay for specified milliseconds (4mhz clock)
milliseconds EQU 0x2F ;set to #ms to delay
delaycounter EQU 0x30
innercounter EQU 0x31

MSdelay
;loop delaycounter from milliseconds
 MOVF milliseconds,0
 MOVWF delaycounter
local__12
;rem execute 997 instructions (1ms - overhead)
;innercounter = #249
 MOVLW 249
 MOVWF innercounter
MSdelay1
 NOP
 DECFSZ innercounter,F
 GOTO MSdelay1
 NOP
;next delaycounter
 DECFSZ delaycounter,1
 GOTO local__12
;return
 RETLW 0

 end

